
'// Day / Night Pong by Tennisball


'// Fenster

Graphics 640, 480


'// "Zufallsgenerator initialisieren"

SeedRnd MilliSecs()


'// Frametimer

Local Timer:TTimer = CreateTimer( 60 )


'// Ob es gerade Nacht ist

Global Night:Byte


'// Die Zeit die das Spiel luft

Global Time:Int


'// PowerUp-Grafik laden

Global imgPowerUp:TImage = LoadImage( "powerup.png" )


'// Spielertype

Type TPlayer
	
	Field Y:Int
	Field nr:Byte
	Field isKi:Byte
	Field Points:Byte
	Field Speed:Int
	
	Method Draw()
		
		If Self.nr = 1 Then DrawRect 34, Self.Y, 1, 120 ; DrawRect 10, Self.Y, 20, 120
		If Self.nr = 2 Then DrawRect 605, Self.Y, 1, 120 ; DrawRect 610, Self.Y, 20, 120
		
		DrawText Self.Points, 300 + ( nr - 1 ) * 30, 10
		
		If Self.Points = 10 Then EndGame( Self.nr )
		
	End Method
	
	Method Move()
		
		If Self.isKi = True Then
			
			Local B:TBall
			Local LowestX:Short = 12345
			Local Y2:Short
			
			For B:TBall = EachIn Balllist
				
				If B.X# < LowestX Then LowestX = B.X# ; Y2 = B.Y#
				
			Next
			
			If Self.Y + 60 > Y2 Then Self.Y :-( Speed ) 								' <- Seht ihr den Smilie ???????
			If Self.Y + 60 < Y2 Then Self.Y :+( Speed )
			
		Else
			
			If Self.nr = 1 Then
				
				Self.Y :- KeyDown( KEY_W ) * Speed
				Self.Y :+ KeyDown( KEY_S ) * Speed
				
			End If
			
			If Self.nr = 2 Then
				
				Self.Y :- KeyDown( KEY_UP ) * Speed
				Self.Y :+ KeyDown( KEY_DOWN ) * Speed
				
			End If
			
		End If
		
	End Method
	
End Type

Global Player1:TPlayer
Global Player2:TPlayer


'// Balltype

Type TBall
	
	Field X#
	Field Y#
	Field Angle:Int
	Field Speed:Int
	Field LastPlayer:Byte
	
	Method Update()
		
		Self.Draw()
		Self.Move()
		Self.CheckCollisions()
		
	End Method
	
	Method Draw()
		
		DrawRect Self.X#, Self.Y#, 30, 30
		
	End Method
	
	Method Move()
		
		Self.X# = Self.X# - Cos(Self.Angle) * Speed
		Self.Y# = Self.Y# + Sin(Self.Angle) * Speed
		
	End Method
	
	Method CheckCollisions()
		
		Self.CheckCollisionsWall()
		Self.CheckCollisionsPlayers()
		Self.CheckCollisionsPowerUps()
		
	End Method
	
	Method CheckCollisionsWall()
		
		If Self.Y <= 0 Then Self.Angle = 360 - Self.Angle
		If Self.Y >= 450 Then Self.Angle = 360 - Self.Angle
		If Self.X# <= - 30 Then
			Player2.Points :+ 1
			Balllist.Remove Self
			CountBalls :- 1
		End If
		If Self.X# >= 640 Then
			Player1.Points :+ 1
			Balllist.Remove Self
			CountBalls :- 1
		End If
		
		If CountBalls = 0 Then AddBall()
		
	End Method
	
	Method CheckCollisionsPlayers()
		
		If RectsOverlap( Self.X#, Self.Y#, 30, 30, 35, Player1.Y, 1, 120 ) And Self.X# => 34 - Self.Speed Then
			
			Self.X# = 38
			Self.Angle = 180 - Self.Angle + Rand( -20, 20 )
			Self.LastPlayer = 1
			
		End If
		
		
		If RectsOverlap( Self.X#, Self.Y#, 30, 30, 605, Player2.Y, 1, 120 ) And Self.X# <= 580 + Self.Speed Then
			
			Self.X# = 577
			Self.Angle = 180 - Self.Angle + Rand( -20, 20 )
			Self.LastPlayer = 2
			
		End If
		
	End Method
	
	Method CheckCollisionsPowerUps()
		
		For Local P:TPowerUp = EachIn PowerUpList
			
			If RectsOverlap( Self.X#, Self.Y#, 30, 30, P.X, P.Y, 30, 30 ) Then
				
				GetPowerUp( P, Self )
				PowerUpList.Remove P
				
			End If
			
		Next
		
	End Method
	
End Type

Global Balllist:TList = CreateList()

Global CountBalls:Byte


'// Poweruptype

Type TPowerUp
	
	Field X:Int
	Field Y:Int
	Field Typ:Byte
	
	Method Draw()
		
		DrawImage imgPowerUp, Self.X, Self.Y
		
	End Method
	
End Type

Global PowerUpList:TList = CreateList()

Const POWERUP_FASTBALL = 1
Const POWERUP_SLOWBALL = 2
Const POWERUP_ADDBALL = 3
Const POWERUP_SLOWBAT = 4
Const POWERUP_FASTBAT = 5
Const POWERUP_REVERSE = 6


'// Fragen ob der Spieler gegen den PC spielen mchte oder gegen seinen Kumpel

FlushKeys()

DrawText "Wenn du gegen den Computer spielen willst, dann druecke 1", 5, 5
DrawText "Wenn du gegen einen anderen Menschen spielen willst, dann druecke nicht 1", 5, 20

Flip

WaitKey()

If GetChar() = 49 Then VersusPC = True


'// Spiel initialisieren

Player1 = New TPlayer
Player1.Y = 260
Player1.nr = 1
Player1.Speed = 5
Player1.isKi = VersusPC

Player2 = New TPlayer
Player2.Y = 260
Player2.nr = 2
Player2.Speed = 5

AddBall()


'// Mainloop

While Not KeyHit( KEY_ESCAPE )
	
	For B:TBall = EachIn Balllist
		
		B.Update()
		
	Next
	
	For P:TPowerUp = EachIn PowerUpList
		
		P.Draw()
		
	Next
	
	Player1.Draw()
	Player1.Move()
	
	Player2.Draw()
	Player2.Move()
	
	ChangeTime()
	
	WaitTimer Timer
	Flip 1
	Cls
	
Wend


'// Spiel beenden

End


'// Funktion zum bestimmen der Tageszeit etc.

Function ChangeTime()
	
	Time :+ 1
	
	If Time Mod 600 = 0 Then
		
		Night = Not Night
		
		Local B:TBall
		
		For B:TBall = EachIn Balllist
			
			If Night = 0 Then B.Speed = 4
			If Night = 1 Then B.Speed = 2			
		Next
		
		If Night = 1 Then SetColor 60, 60, 60
		If Night = 0 Then SetColor 255,255,255 ; CreatePowerUps()
	
	End If
	
End Function


'// Funktion zum Erstellen von PowerUps

Function CreatePowerUps()
	
	For Local I:Byte = 1 To 3
		
		Local P:TPowerUp = New TPowerUp
		PowerUpList.AddLast P
		P.X = Rand( 50, 560 )
		P.Y = Rand( 50, 400 )
		P.Typ = Rand( 1, 6 )
		
	Next
	
End Function


'// Funktion zum Einsammeln eines PowerUps

Function GetPowerUp( P:TPowerUp, B:TBall )

	Select P.Typ
		
		Case POWERUP_FASTBALL
			B.Speed :+ 1
			
		Case POWERUP_SLOWBALL
			B.Speed :- 1
			
		Case POWERUP_ADDBALL
			AddBall()
			
		Case POWERUP_SLOWBAT
			If B.LastPlayer = 1 Then Player1.Speed :- 1
			If B.LastPlayer = 2 Then Player2.Speed :- 1
			
		Case POWERUP_FASTBAT
			If B.LastPlayer = 1 Then Player1.Speed :+ 1
			If B.LastPlayer = 2 Then Player2.Speed :+ 1
			
		Case POWERUP_REVERSE
			If B.LastPlayer = 1 And Player1.isKi = False Then Player1.Speed :* -1
			If B.LastPlayer = 2 And Player2.isKi = False Then Player2.Speed :* -1
			
	End Select
	
End Function


'// Funktion zum Hinzufgen eines Balles

Function AddBall()
	
	Local B:TBall = New TBall
	Balllist.AddLast B
	B.X = 320
	B.Y = 240
	B.Angle = Rand( 0, 1 ) * 180
	B.Speed = 4
	
	CountBalls :+ 1
	
End Function


'// Das Spiel beenden und Sieger verknden

Function EndGame( winner:Byte )
	
	FlushKeys()
	Cls
	Flip
	DrawText "Spieler " + winner + " hat gewonnen!", 200, 200
	Flip
	Delay 1000
	WaitKey()
	End
	
End Function


'// Rechteckskollsionsfunktion

Function RectsOverlap( X1, Y1, W1, H1, X2, Y2, W2, H2 )
	
	XL = X1
	YO = Y1
	XR = X2 + W2
	YU = Y2 + H2
	If X2 < X1 Then XL = X2
	If Y2 < Y1 Then YO = Y2
	If X1 + W1 > X2 + W2 Then XR = X1 + W1
	If Y1 + H1 > Y2 + H2 Then YU = Y1 + H1
	
	Return (W1 + W2 > XR - XL And H1 + H2 > YU - YO)
	
End Function